/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: r_eq.c,v 1.2 1997/09/25 17:45:39 ae59 Exp $ */
/*
$Log: r_eq.c,v $
 * Revision 1.2  1997/09/25  17:45:39  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:56  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : r_eq.c                                */
/*                                                              */
/*      Entries         : a_bool r_eq(a,b)                      */
/*                        a_real a,b;                           */
/*                                                              */
/*      Arguments       : a = IEEE operand                      */
/*                        b = IEEE operand                      */
/*                                                              */
/*      Function value  : TRUE if values are equal              */
/*                        FALSE if values are not equal         */
/*                                                              */
/*      Description     : compare IEEE values                   */
/*                                                              */
/*      Date            : 1991-04-23                            */
/*      1991-04-23 : MANT_INFINITY() used                       */
/*      1990-11-19 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_bool r_eq(a_real a,a_real b)
#else
local a_bool r_eq(a,b)

a_real a;
a_real b;
#endif
        {
        a_bool zeroa,zerob,vza,vzb,res;
        a_intg expoa,expob;
        a_btyp manta[D_U_RATIO];
        a_btyp mantb[D_U_RATIO];

        E_TPUSH("r_eq")

        zeroa = b_deko(a,&expoa,manta,&vza);
        zerob = b_deko(b,&expob,mantb,&vzb);

        if (expoa>=EXPO_MAX+1 || expob>=EXPO_MAX+1) {
           if (expoa==EXPO_MAX+1 && expob==EXPO_MAX+1)
              {
#if C_P_3
              if (manta[0]==mantb[0] && manta[1]==mantb[1])
#else
              if (b_bmcm(D_U_RATIO,manta,mantb)==0)
#endif
                 {
                 if (MANT_INFINITY(manta))
                    res = (vza==vzb) ? TRUE : FALSE;
                 else res = TRUE;
                 }
              else res = FALSE;
              }
           else
              res = FALSE;
           }
        else if (zeroa) res = (zerob) ? TRUE : FALSE;
        else if (zerob) res = FALSE;
        else if (vza!=vzb) res = FALSE;
        else if (expoa!=expob) res = FALSE;
#if C_P_3
        else if (manta[0]!=mantb[0] || manta[1]!=mantb[1])
           res = FALSE;
#else
        else if (b_bmcm(D_U_RATIO,manta,mantb)!=0) res = FALSE;
#endif
        else res = TRUE;

        E_TPOPP("r_eq")
        return(res);
        }
